]> git.pld-linux.org Git - packages/rpm-build-tools.git/blame_incremental - builder.sh
- allow forcing ipv4/ipv6
[packages/rpm-build-tools.git] / builder.sh
... / ...
CommitLineData
1#!/bin/ksh
2#
3# This program is free software, distributed under the terms of
4# the GNU General Public License Version 2.
5#
6# -----------
7# Exit codes:
8# 0 - succesful
9# 1 - help displayed
10# 2 - no spec file name in cmdl parameters
11# 3 - spec file not stored in repo
12# 4 - some source, patch or icon files not stored in repo
13# 5 - package build failed
14# 6 - spec file with errors
15# 7 - wrong source in /etc/poldek.conf
16# 8 - Failed installing buildrequirements and subrequirements
17# 9 - Requested tag already exist
18# 10 - Refused to build fractional release
19# 100 - Unknown error (should not happen)
20
21# Notes (todo/bugs):
22# - when Icon: field is present, -5 and -a5 doesn't work
23# - builder -R skips installing BR if spec is not present before builder invocation (need to run builder twice)
24# - does not respect NoSource: X, and tries to cvs up such files [ example: VirtualBox-bin.spec and its Source0 ]
25# TODO:
26# - ability to do ./builder -bb foo.spec foo2.spec foo3.spec
27# - funny bug, if source-md5 is set then builder will download from distfiles even if there is no url present:
28# Source10: forwardfix.pl
29# # Source10-md5: 8bf85f7368933a4e0cb4f875bac28733
30# - builder --help:
31# basename: missing operand
32# Try `basename --help' for more information.
33# -- and the normal usage info --
34
35PROGRAM=${0##*/}
36APPDIR=$(d=$0; [ -L "$d" ] && d=$(readlink -f "$d"); dirname "$d")
37RCSID='$Id$' r=${RCSID#* * } rev=${r%% *}
38VERSION="v0.35/$rev"
39VERSIONSTRING="\
40Build package utility from PLD Linux Packages repository
41$VERSION (C) 1999-2011 Free Penguins".
42
43PATH="/bin:/usr/bin:/usr/sbin:/sbin:/usr/X11R6/bin"
44
45# required rpm-build-macros
46RPM_MACROS_VER=1.534
47
48COMMAND="build"
49TARGET=""
50
51SPECFILE=""
52BE_VERBOSE=""
53QUIET=""
54CLEAN=""
55DEBUG=""
56NOURLS=""
57NOCVS=""
58NOCVSSPEC=""
59NODIST=""
60NOINIT=""
61PREFMIRRORS=""
62UPDATE=""
63ADD5=""
64NO5=""
65ALWAYS_CVSUP=${ALWAYS_CVSUP:-"yes"}
66CVSROOT=""
67GREEDSRC=""
68
69# use rpm 4.4.6+ digest format instead of comments if non-zero
70USEDIGEST=
71
72# user agent when fetching files
73USER_AGENT="PLD/Builder($VERSION)"
74
75# It can be used i.e. in log file naming.
76# See LOGFILE example.
77DATE=`date +%Y-%m-%d_%H-%M-%S`
78
79# Example: LOGFILE='../log.$PACKAGE_NAME'
80# Example: LOGFILE='../LOGS/log.$PACKAGE_NAME.$DATE'
81# Example: LOGFILE='$PACKAGE_NAME/$PACKAGE_NAME.$DATE.log'
82# Example: LOGFILE='$PACKAGE_NAME.$DATE.log'
83# Yes, you can use variable name! Note _single_ quotes!
84LOGFILE=''
85
86LOGDIR=""
87LOGDIROK=""
88LOGDIRFAIL=""
89LASTLOG_FILE=""
90
91CHMOD="no"
92CHMOD_MODE="0644"
93RPMOPTS=""
94RPMBUILDOPTS=""
95BCOND=""
96GROUP_BCONDS="no"
97
98# create symlinks for tools in PACKAGE_DIR, see get_spec()
99SYMLINK_TOOLS="no"
100
101PATCHES=""
102SOURCES=""
103ICONS=""
104PACKAGE_RELEASE=""
105PACKAGE_VERSION=""
106PACKAGE_NAME=""
107ASSUMED_NAME=""
108PROTOCOL="http"
109WGET_RETRIES=${MAX_WGET_RETRIES:-0}
110
111CVS_COMMAND=${CVS_COMMAND:-cvs}
112CVS_FORCE=""
113CVSIGNORE_DF="yes"
114CVS_RETRIES=${MAX_CVS_RETRIES:-1000}
115CVS_SERVER="cvs.pld-linux.org"
116CVSTAG=""
117
118RES_FILE=""
119
120DISTFILES_SERVER="://distfiles.pld-linux.org"
121ATTICDISTFILES_SERVER="://attic-distfiles.pld-linux.org"
122
123DEF_NICE_LEVEL=19
124SCHEDTOOL="auto"
125
126FAIL_IF_NO_SOURCES="yes"
127
128# let get_files skip over files which are present to get those damn files fetched
129SKIP_EXISTING_FILES="no"
130
131TRY_UPGRADE=""
132# should the specfile be restored if upgrade failed?
133REVERT_BROKEN_UPGRADE="yes"
134
135if rpm --specsrpm 2>/dev/null; then
136 FETCH_BUILD_REQUIRES_RPMSPECSRPM="yes"
137 FETCH_BUILD_REQUIRES_RPMGETDEPS="no"
138else
139 FETCH_BUILD_REQUIRES_RPMSPECSRPM="no"
140 if [ -x /usr/bin/rpm-getdeps ]; then
141 FETCH_BUILD_REQUIRES_RPMGETDEPS="yes"
142 else
143 FETCH_BUILD_REQUIRES_RPMGETDEPS="no"
144 fi
145fi
146
147
148# Here we load saved user environment used to
149# predefine options set above, or passed to builder
150# in command line.
151# This one reads global system environment settings:
152if [ -f ~/etc/builderrc ]; then
153 . ~/etc/builderrc
154fi
155# And this one cascades settings using user personal
156# builder settings.
157# Example of ~/.builderrc:
158#
159#UPDATE_POLDEK_INDEXES="yes"
160#FETCH_BUILD_REQUIRES="yes"
161#REMOVE_BUILD_REQUIRES="force"
162#GROUP_BCONDS="yes"
163#LOGFILE='../LOGS/log.$PACKAGE_NAME.$DATE'
164#TITLECHANGE=no
165#
166SU_SUDO=""
167if [ -n "$HOME_ETC" ]; then
168 USER_CFG="$HOME_ETC/.builderrc"
169 BUILDER_MACROS="$HOME_ETC/.builder-rpmmacros"
170else
171 USER_CFG=~/.builderrc
172 BUILDER_MACROS=~/.builder-rpmmacros
173fi
174
175[ -f "$USER_CFG" ] && . "$USER_CFG"
176
177if [ "$SCHEDTOOL" = "auto" ]; then
178 if [ -x /usr/bin/schedtool ] && schedtool -B -e echo >/dev/null; then
179 SCHEDTOOL="schedtool -B -e"
180 else
181 SCHEDTOOL="no"
182 fi
183fi
184
185if [ -n "$USE_PROZILLA" ]; then
186 GETURI="proz --no-getch -r -P ./ -t$WGET_RETRIES $PROZILLA_OPTS"
187 GETURI2="$GETURI"
188 OUTFILEOPT="-O"
189elif [ -n "$USE_AXEL" ]; then
190 GETURI="axel -a $AXEL_OPTS"
191 GETURI2="$GETURI"
192 OUTFILEOPT="-o"
193else
194 wget --help 2>&1 | grep -q -- ' --no-check-certificate ' && WGET_OPTS="$WGET_OPTS --no-check-certificate"
195 wget --help 2>&1 | grep -q -- ' --inet ' && WGET_OPTS="$WGET_OPTS --inet"
196 wget --help 2>&1 | grep -q -- ' --retry-connrefused ' && WGET_OPTS="$WGET_OPTS --retry-connrefused"
197 WGET_OPTS="$WGET_OPTS --user-agent=$USER_AGENT"
198
199 GETURI="wget --passive-ftp -c -nd -t$WGET_RETRIES $WGET_OPTS"
200 GETURI2="wget -c -nd -t$WGET_RETRIES $WGET_OPTS"
201 OUTFILEOPT="-O"
202fi
203
204GETLOCAL="cp -a"
205
206if (rpm --version 2>&1 | grep -q '4.0.[0-2]'); then
207 RPM="rpm"
208 RPMBUILD="rpm"
209else
210 RPM="rpm"
211 RPMBUILD="rpmbuild"
212fi
213
214#
215# sanity checks
216#
217if [ -d $HOME/rpm/SOURCES ]; then
218 echo "ERROR: ~/rpm/{SPECS,SOURCES} structure is obsolete" >&2
219 echo "ERROR: get rid of your ~/rpm/SOURCES" >&2
220 exit 1
221fi
222
223#
224# are we using cvs-nserver ?
225#
226CVS_NSERVER=0
227$CVS_COMMAND --version 2>&1 | grep -q 'CVS-nserver'
228[ $? -eq 0 ] && CVS_NSERVER=1
229
230POLDEK_INDEX_DIR="$($RPM --eval %_rpmdir)/"
231POLDEK_CMD="$SU_SUDO /usr/bin/poldek --noask"
232
233run_poldek() {
234 RES_FILE=$(tempfile)
235 if [ -n "$LOGFILE" ]; then
236 LOG=`eval echo $LOGFILE`
237 if [ -n "$LASTLOG_FILE" ]; then
238 echo "LASTLOG=$LOG" > $LASTLOG_FILE
239 fi
240 (${NICE_COMMAND} ${POLDEK_CMD} `while test $# -gt 0; do echo "$1 ";shift;done` ; echo $? > ${RES_FILE})|tee -a $LOG
241 return $exit_pldk
242 else
243 (${NICE_COMMAND} ${POLDEK_CMD} `while test $# -gt 0; do echo "$1 ";shift;done` ; echo $? > ${RES_FILE}) 1>&2 >/dev/null
244 return `cat ${RES_FILE}`
245 rm -rf ${RES_FILE}
246 fi
247}
248
249#---------------------------------------------
250# functions
251
252usage() {
253 if [ -n "$DEBUG" ]; then set -xv; fi
254 echo "\
255Usage: builder [-D|--debug] [-V|--version] [--short-version] [--as_anon] [-a|--add_cvs] [-b|-ba|--build]
256[-bb|--build-binary] [-bs|--build-source] [-bc] [-bi] [-bl] [-u|--try-upgrade]
257[{-cf|--cvs-force}] [{-B|--branch} <branch>] [{-d|--cvsroot} <cvsroot>]
258[-g|--get] [-h|--help] [--ftp] [--http] [{-l|--logtofile} <logfile>] [-m|--mr-proper]
259[-q|--quiet] [--date <yyyy-mm-dd> [-r <cvstag>] [{-T|--tag <cvstag>]
260[-Tvs|--tag-version-stable] [-Ts|--tag-stable] [-Tv|--tag-version]
261[{-Tp|--tag-prefix} <prefix>] [{-tt|--test-tag}] [--use-greed-sources]
262[-nu|--no-urls] [-v|--verbose] [--opts <rpm opts>] [--short-circuit]
263[--show-bconds] [--with/--without <feature>] [--define <macro> <value>]
264<package>[.spec][:cvstag]
265
266-4 - force ipv4 when transferring files
267-5, --update-md5 - update md5 comments in spec, implies -nd -ncs
268-6 - force ipv6 when transferring files
269-a5, --add-md5 - add md5 comments to URL sources, implies -nc -nd -ncs
270-n5, --no-md5 - ignore md5 comments in spec
271-D, --debug - enable builder script debugging mode,
272-debug - produce rpm debug package (same as --opts -debug)
273-V, --version - output builder version string
274--short-version - output builder short version
275--as_anon - get files via pserver as cvs@$CVS_SERVER,
276-a, --add_cvs - try add new package to CVS.
277-b, -ba, --build - get all files from CVS repo or HTTP/FTP and build package
278 from <package>.spec,
279-bb, --build-binary - get all files from CVS repo or HTTP/FTP and build binary
280 only package from <package>.spec,
281-bp, --build-prep - execute the %prep phase of <package>.spec,
282-bc - execute the %build phase of <package>.spec,
283-bi - execute the %install phase of <package>.spec
284-bl - execute the %files phase of <package>.spec
285-bs, --build-source - get all files from CVS repo or HTTP/FTP and only pack
286 them into src.rpm,
287--short-circuit - short-circuit build
288-B, --branch - add branch
289-c, --clean - clean all temporarily created files (in BUILD\$RPM_BUILD_ROOT) after rpmbuild commands.
290 may be used with building process.
291-m, --mr-proper - clean all temporarily created files (in BUILD, SOURCES,
292 SPECS and \$RPM_BUILD_ROOT and CVS/Entries). Doesn't run
293 any rpm building.
294-cf, --cvs-force - use -F when tagging (useful when moving branches)
295-d <cvsroot>, --cvsroot <cvsroot>
296 - setup \$CVSROOT,
297--define <macro> <value>
298 - define a macro <macro> with value <value>,
299--alt_kernel <kernel>
300 - same as --define 'alt_kernel <kernel>'
301--nodeps - rpm won't check any dependences
302-g, --get - get <package>.spec and all related files from CVS repo
303 or HTTP/FTP,
304-h, --help - this message,
305-jN, -j N - set %_smp_mflags to propagate concurrent jobs
306--ftp, --http - use ftp or http protocol to access distfiles server
307-l <logfile>, --logtofile <logfile>
308 - log all to file,
309-nc, --no-cvs - don't download sources from CVS, if source URL is given,
310-ncs, --no-cvs-specs
311 - don't check specs in CVS
312-nd, --no-distfiles - don't download from distfiles
313-nm, --no-mirrors - don't download from mirror, if source URL is given,
314-nu, --no-urls - don't try to download from FTP/HTTP location,
315-ns, --no-srcs - don't download Sources/Patches
316-ns0, --no-source0 - don't download Source0
317-nn, --no-net - don't download anything from the net
318-pm, --prefer-mirrors - prefer mirrors (if any) over distfiles for SOURCES
319--no-init - don't initialize builder paths (SPECS and SOURCES)
320-ske,
321--skip-existing-files - skip existing files in get_files
322--opts <rpm opts> - additional options for rpm
323-q, --quiet - be quiet,
324--date yyyy-mm-dd - build package using resources from specified CVS date,
325-r <cvstag>, --cvstag <cvstag>
326 - build package using resources from specified CVS tag,
327-A - build package using CVS resources as any sticky tags/date/kopts being reset.
328-R, --fetch-build-requires
329 - fetch what is BuildRequired,
330-RB, --remove-build-requires
331 - remove all you fetched with -R or --fetch-build-requires
332 remember, this option requires confirmation,
333-FRB, --force-remove-build-requires
334 - remove all you fetched with -R or --fetch-build-requires
335 remember, this option works without confirmation,
336-sd, --source-distfiles - list sources available from distfiles (intended for offline
337 operations; does not work when Icon field is present
338 but icon file is absent),
339-sc, --source-cvs - list sources available from CVS
340-sdp, --source-distfiles-paths - list sources available from distfiles -
341 paths relative to distfiles directory (intended for offline
342 operations; does not work when Icon field is present
343 but icon file is absent),
344-sf, --source-files - list sources - bare filenames (intended for offline
345 operations; does not work when Icon field is present
346 but icon file is absent),
347-lsp, --source-paths - list sources - filenames with full local paths (intended for
348 offline operations; does not work when Icon field is present
349 but icon file is absent),
350-su, --source-urls - list urls - urls to sources and patches
351 intended for copying urls with spec with lots of macros in urls
352-T <cvstag> , --tag <cvstag>
353 - add cvs tag <cvstag> for files,
354-Tvs, --tag-version-stable
355 - add cvs tags STABLE and NAME-VERSION-RELEASE for files,
356-Ts, --tag-stable
357 - add cvs tag STABLE for files,
358-Tv, --tag-version
359 - add cvs tag NAME-VERSION-RELEASE for files,
360-Tp, --tag-prefix <prefix>
361 - add <prefix> to NAME-VERSION-RELEASE tags,
362-tt, --test-tag <prefix>
363 - fail if tag is already present,
364-ir, --integer-release-only
365 - allow only integer and snapshot releases
366-v, --verbose - be verbose,
367-u, --try-upgrade - check version, and try to upgrade package
368-un, --try-upgrade-with-float-version
369 - as above, but allow float version
370 php-pear-Services_Digg/
371--upgrade-version - upgrade to specified version in try-upgrade
372--use-greed-sources
373 - try download source from tag head if don't find it in
374 current tag
375-U, --update - refetch sources, don't use distfiles, and update md5 comments
376-Upi, --update-poldek-indexes
377 - refresh or make poldek package index files.
378-sp, --skip-patch <patchnumber>
379 - don't apply <patchnumber>. may be repeated.
380-np, --nopatch <patchnumber>
381 - abort instead of applying patch <patchnumber>
382--show-bconds - show available conditional builds, which can be used
383 - with --with and/or --without switches.
384--show-bcond-args - show active bconds, from ~/.bcondrc. this is used by
385 ./repackage.sh script. in other words, the output is
386 parseable by scripts.
387--show-avail-bconds - show available bconds
388--with/--without <feature>
389 - conditional build package depending on %_with_<feature>/
390 %_without_<feature> macro switch. You may now use
391 --with feat1 feat2 feat3 --without feat4 feat5 --with feat6
392 constructions. Set GROUP_BCONDS to yes to make use of it.
393--target <platform>, --target=<platform>
394 - build for platform <platform>.
395--init-rpm-dir - initialize ~/rpm directory structure
396"
397}
398
399# create tempfile. as secure as possible
400tempfile() {
401 mktemp -t builder.XXXXXX || ${TMPDIR:-/tmp}/builder.$RANDOM.$$
402}
403
404# change dependency to specname
405# common changes:
406# - perl(Package::Name) -> perl-Package-Name
407depspecname() {
408 local package="$1"
409
410 package=$(echo "$package" | sed -e '/perl(.*)/{s,perl(\(.*\)),perl-\1,;s,::,-,g};' -e 's/-\(devel\|static\)$//' )
411 echo "$package"
412}
413
414update_shell_title() {
415 [ -t 1 ] || return
416 local len=${COLUMNS:-80}
417 local msg="$(echo "$*" | cut -c-$len)"
418
419 if [ -n "$BE_VERBOSE" ]; then
420 echo >&2 "$(date +%s.%N) $*"
421 fi
422
423 if [ "x$TITLECHANGE" = "xyes" -o "x$TITLECHANGE" = "x" ]; then
424 local pkg
425 if [ -n "$PACKAGE_NAME" ]; then
426 pkg=${PACKAGE_NAME}-${PACKAGE_VERSION}-${PACKAGE_RELEASE}
427 else
428 pkg=${SPECFILE}
429 fi
430
431 msg="$pkg: ${SHELL_TITLE_PREFIX:+$SHELL_TITLE_PREFIX }$msg"
432 msg=$(echo $msg | tr -d '\n\r')
433 case "$TERM" in
434 cygwin|xterm*)
435 echo >&2 -ne "\033]1;$msg\007\033]2;$msg\007"
436 ;;
437 screen*)
438 echo >&2 -ne "\033]0;$msg\007"
439 ;;
440 esac
441 fi
442}
443
444# set TARGET from BuildArch: from SPECFILE
445set_spec_target() {
446 if [ -n "$SPECFILE" ] && [ -z "$TARGET" ]; then
447 tmp=$(awk '/^BuildArch:/ { print $NF; exit }' $ASSUMED_NAME/$SPECFILE)
448 if [ "$tmp" ]; then
449 target_platform=$(rpm -E '%{_target_vendor}-%{_target_os}%{?_gnu}')
450 TARGET="$tmp"
451 case "$RPMBUILD" in
452 "rpmbuild")
453 TARGET_SWITCH="--target ${TARGET}-${target_platform}" ;;
454 "rpm")
455 TARGET_SWITCH="--target=$TARGET" ;;
456 esac
457 fi
458 fi
459}
460
461# runs rpm with minimal macroset
462minirpm() {
463 # we reset macros not to contain macros.build as all the %() macros are
464 # executed here, while none of them are actually needed.
465 # at the time of this writing macros.build + macros contained 70 "%(...)" macros.
466 safe_macrofiles=$(rpm $TARGET_SWITCH --showrc | awk -F: '/^macrofiles/ { gsub(/^macrofiles[ \t]+:/, "", $0); gsub(/:.*macros.build:/, ":", $0); print $0 } ')
467
468 # TODO: move these to /usr/lib/rpm/macros
469 cat > $BUILDER_MACROS <<'EOF'
470%x8664 x86_64 amd64 ia32e
471%alt_kernel %{nil}
472%_alt_kernel %{nil}
473%bootstrap_release() %{1}
474%requires_releq_kernel_up(s:n:) %{nil}
475%requires_releq_kernel_smp(s:n:) %{nil}
476%requires_releq_kernel(s:n:) %{nil}
477%requires_releq() %{nil}
478%pyrequires_eq() %{nil}
479%requires_eq() %{nil}
480%requires_eq_to() %{nil}
481%requires_ge() %{nil}
482%requires_ge_to() %{nil}
483%requires_ge() %{nil}
484%releq_kernel_up(n:) ERROR
485%releq_kernel_smp(n:) ERROR
486%releq_kernel(n:) ERROR
487%kgcc_package ERROR
488%_fontsdir ERROR
489%ruby_version ERROR
490%ruby_ver_requires_eq() %{nil}
491%ruby_mod_ver_requires_eq() %{nil}
492%__php_api_requires() %{nil}
493%php_major_version ERROR
494%php_api_version ERROR
495%requires_xorg_xserver_extension %{nil}
496%requires_xorg_xserver_xinput %{nil}
497%requires_xorg_xserver_font %{nil}
498%requires_xorg_xserver_videodrv %{nil}
499%py_ver ERROR
500%perl_vendorarch ERROR
501%perl_vendorlib ERROR
502# damn. need it here! - copied from /usr/lib/rpm/macros.build
503%tmpdir %(echo "${TMPDIR:-/tmp}")
504%patchset_source(f:b:) %(
505 base=%{-b*}%{!-b*:10000};
506 start=$(expr $base + %1);
507 end=$(expr $base + %{?2}%{!?2:%{1}});
508 # we need to call seq twice as it doesn't allow two formats
509 seq -f 'Patch%g:' $start $end > %{tmpdir}/__ps1;
510 seq -f '%{-f*}' %1 %{?2}%{!?2:%{1}} > %{tmpdir}/__ps2;
511 paste %{tmpdir}/__ps{1,2};
512 rm -f %{tmpdir}/__ps{1,2};
513) \
514%{nil}
515%add_etc_shells(p) %{p:<lua>}
516%remove_etc_shells(p) %{p:<lua>}
517%lua_add_etc_shells() %{nil}
518%lua_remove_etc_shells() %{nil}
519%required_jdk %{nil}
520%buildrequires_jdk %{nil}
521%pear_package_print_optionalpackages %{nil}
522EOF
523 if [ "$NOINIT" = "yes" ] ; then
524 cat >> $BUILDER_MACROS <<'EOF'
525%_specdir ./
526%_sourcedir ./
527EOF
528 fi
529 eval $RPMBUILD $TARGET_SWITCH --macros "$safe_macrofiles:$BUILDER_MACROS" $QUIET $RPMOPTS $RPMBUILDOPTS $BCOND $* 2>&1
530}
531
532cache_rpm_dump() {
533 if [ -n "$DEBUG" ]; then
534 set -x
535 set -v
536 fi
537
538 if [ -x /usr/bin/rpm-specdump ]; then
539 update_shell_title "cache_rpm_dump using rpm-specdump command"
540 rpm_dump_cache=$(rpm-specdump $TARGET_SWITCH $BCOND $SPECFILE)
541 else
542 update_shell_title "cache_rpm_dump using rpmbuild command"
543 local rpm_dump
544 rpm_dump=`
545 # what we need from dump is NAME, VERSION, RELEASE and PATCHES/SOURCES.
546 dump='%{echo:dummy: PACKAGE_NAME %{name} }%dump'
547 case "$RPMBUILD" in
548 rpm)
549 ARGS='-bp'
550 ;;
551 rpmbuild)
552 ARGS='--nodigest --nosignature --nobuild'
553 ;;
554 esac
555 minirpm $ARGS --define "'prep $dump'" --nodeps $SPECFILE
556 `
557 if [ $? -gt 0 ]; then
558 error=$(echo "$rpm_dump" | sed -ne '/^error:/,$p')
559 echo "$error" >&2
560 Exit_error err_build_fail
561 fi
562
563 # make small dump cache
564 rpm_dump_cache=`echo "$rpm_dump" | awk '
565 $2 ~ /^SOURCEURL/ {print}
566 $2 ~ /^PATCHURL/ {print}
567 $2 ~ /^nosource/ {print}
568 $2 ~ /^PACKAGE_/ {print}
569 '`
570 fi
571
572 update_shell_title "cache_rpm_dump: OK!"
573}
574
575rpm_dump() {
576 if [ -z "$rpm_dump_cache" ] ; then
577 echo >&2 "internal error: cache_rpm_dump not called! (missing %prep?)"
578 fi
579 echo "$rpm_dump_cache"
580}
581
582get_icons() {
583 update_shell_title "get icons"
584 ICONS=$(awk '/^Icon:/ {print $2}' $PACKAGE_DIR/${SPECFILE})
585 if [ -z "$ICONS" ]; then
586 return
587 fi
588
589 rpm_dump_cache="kalasaba" NODIST="yes" get_files $ICONS
590}
591
592parse_spec() {
593 update_shell_title "parsing specfile"
594 if [ -n "$DEBUG" ]; then
595 set -x
596 set -v
597 fi
598
599 # icons are needed for successful spec parse
600 get_icons
601
602 cd $PACKAGE_DIR
603 cache_rpm_dump
604
605 if (rpm_dump | grep -qEi ":.*nosource.*1"); then
606 FAIL_IF_NO_SOURCES="no"
607 fi
608
609 if [ "$NOSRCS" != "yes" ]; then
610 SOURCES=$(rpm_dump | awk '$2 ~ /^SOURCEURL[0-9]+/ {print substr($2, length("SOURCEURL") + 1), $3}' | LC_ALL=C sort -n | awk '{print $2}')
611 PATCHES=$(rpm_dump | awk '$2 ~ /^PATCHURL[0-9]+/ {print substr($2, length("PATCHURL") + 1), $3}' | LC_ALL=C sort -n | awk '{print $2}')
612 ICONS=$(awk '/^Icon:/ {print $2}' ${SPECFILE})
613 fi
614
615 PACKAGE_NAME=$(rpm_dump | awk '$2 == "PACKAGE_NAME" { print $3; exit}')
616 PACKAGE_VERSION=$(rpm_dump | awk '$2 == "PACKAGE_VERSION" { print $3; exit}')
617 PACKAGE_RELEASE=$(rpm_dump | awk '$2 == "PACKAGE_RELEASE" { print $3; exit}')
618
619 if [ "$PACKAGE_NAME" != "$ASSUMED_NAME" ]; then
620 echo >&2 "WARNING! Spec name ($ASSUMED_NAME) does not agree with package name ($PACKAGE_NAME)"
621 fi
622
623 if [ -n "$BE_VERBOSE" ]; then
624 echo "- Sources : `nourl $SOURCES`"
625 if [ -n "$PATCHES" ]; then
626 echo "- Patches : `nourl $PATCHES`"
627 else
628 echo "- Patches : *no patches needed*"
629 fi
630 if [ -n "$ICONS" ]; then
631 echo "- Icon : `nourl $ICONS`"
632 else
633 echo "- Icon : *no package icon*"
634 fi
635 echo "- Name : $PACKAGE_NAME"
636 echo "- Version : $PACKAGE_VERSION"
637 echo "- Release : $PACKAGE_RELEASE"
638 fi
639
640 update_shell_title "parse_spec: OK!"
641}
642
643Exit_error() {
644 if [ -n "$DEBUG" ]; then
645 set -x
646 set -v
647 fi
648
649 cd "$__PWD"
650
651 case "$1" in
652 "err_no_spec_in_cmdl" )
653 remove_build_requires
654 echo >&2 "ERROR: spec file name not specified."
655 exit 2 ;;
656 "err_invalid_cmdline" )
657 echo >&2 "ERROR: invalid command line arg ($2)."
658 exit 2 ;;
659 "err_no_spec_in_repo" )
660 remove_build_requires
661 echo >&2 "Error: spec file not stored in CVS repo."
662 exit 3 ;;
663 "err_no_source_in_repo" )
664 remove_build_requires
665 echo >&2 "Error: some source, patch or icon files not stored in CVS repo. ($2)"
666 exit 4 ;;
667 "err_cvs_add_failed" )
668 echo >&2 "Error: failed to add package to CVS repo."
669 exit 4 ;;
670 "err_build_fail" )
671 remove_build_requires
672 echo >&2 "Error: package build failed. (${2:-no more info})"
673 exit 5 ;;
674 "err_no_package_data" )
675 remove_build_requires
676 echo >&2 "Error: couldn't get out package name/version/release from spec file."
677 exit 6 ;;
678 "err_tag_exists" )
679 remove_build_requires
680 echo >&2 "Tag ${2} already exists (spec release: ${3})."
681 exit 9 ;;
682 "err_fract_rel" )
683 remove_build_requires
684 echo >&2 "Release ${2} not integer and not a snapshot."
685 exit 10 ;;
686 "err_branch_exists" )
687 remove_build_requires
688 echo >&2 "Tree branch already exists (${2})."
689 exit 11 ;;
690 "err_acl_deny" )
691 remove_build_requires
692 echo >&2 "Error: conditions reject building this spec (${2})."
693 exit 12 ;;
694 esac
695 echo >&2 "Unknown error."
696 exit 100
697}
698
699init_builder() {
700 if [ -n "$DEBUG" ]; then
701 set -x
702 set -v
703 fi
704
705 if [ "$NOINIT" != "yes" ] ; then
706 TOP_DIR=$(eval $RPM $RPMOPTS --eval '%{_topdir}')
707
708 local macros_ver=$(rpm -E %?rpm_build_macros)
709 if [ -z "$macros_ver" ]; then
710 REPO_DIR=$TOP_DIR/packages
711 PACKAGE_DIR=$TOP_DIR/packages/$ASSUMED_NAME
712 else
713 if awk "BEGIN{exit($macros_ver>=$RPM_MACROS_VER)}"; then
714 echo >&2 "builder requires rpm-build-macros >= $RPM_MACROS_VER"
715 exit 1
716 fi
717 REPO_DIR=$TOP_DIR
718 PACKAGE_DIR=$REPO_DIR/$ASSUMED_NAME
719 fi
720 else
721 REPO_DIR="."
722 PACKAGE_DIR="."
723 fi
724
725 __PWD=$(pwd)
726}
727
728get_spec() {
729
730 update_shell_title "get_spec"
731
732 if [ -n "$DEBUG" ]; then
733 set -x
734 set -v
735 fi
736
737 cd "$REPO_DIR"
738 if [ ! -f "$ASSUMED_NAME/$SPECFILE" ]; then
739 # XXX: still needed?
740 SPECFILE=$(basename $SPECFILE)
741 fi
742
743 if [ "$NOCVSSPEC" != "yes" ]; then
744 if [ ! -s CVS/Root -a "$NOCVSSPEC" != "yes" ]; then
745 echo "Warning: No CVS access defined - using local .spec file"
746 NOCVSSPEC="yes"
747 fi
748
749 if [ -d "$ASSUMED_NAME" -a -s "$ASSUMED_NAME/CVS/Root" ]; then
750 cvsup "$ASSUMED_NAME/$SPECFILE" || Exit_error err_no_spec_in_repo
751 elif [ "$ADD_PACKAGE_CVS" = "yes" ]; then
752 if [ ! -r "$ASSUMED_NAME/$SPECFILE" ]; then
753 echo "ERROR: No package to add ($ASSUMED_NAME/$SPECFILE)" >&2
754 exit 101
755 fi
756 if [ ! -s "$ASSUMED_NAME/CVS/Root" ]; then
757 cvsup -a $ASSUMED_NAME || Exit_error err_cvs_add_failed
758 fi
759 cvsup -a "$ASSUMED_NAME/$SPECFILE" || Exit_error err_cvs_add_failed
760 else
761 cvsup -c -d $ASSUMED_NAME "packages/$ASSUMED_NAME/$SPECFILE" || {
762 # softfail if new package, i.e not yet added to cvs
763 [ ! -f "$ASSUMED_NAME/$SPECFILE" ] && Exit_error err_no_spec_in_repo
764 echo "Warning: package not in CVS - assuming new package"
765 NOCVSSPEC="yes"
766 NOCVS="yes"
767 }
768
769 # remove Entries.Static -- so 'cvs up' would update all files in a repo
770 rm -f "$ASSUMED_NAME/CVS/Entries.Static"
771 fi
772
773 cvsignore_df .cvsignore
774
775 # add default log format to .cvsignore if it is relative to package dir
776 if [ -n "$LOGFILE" -a "$LOGFILE" = "${LOGFILE##*/}" ]; then
777 # substitute known "macros" to glob
778 local logfile=$(echo "$LOGFILE" | sed -e 's,\$\(PACKAGE_NAME\|DATE\),*,g')
779 if [ "$logfile" ]; then
780 cvsignore_df "$logfile"
781 fi
782 fi
783
784 # create symlinks for tools
785 if [ "$SYMLINK_TOOLS" != "no" ]; then
786 for a in dropin md5 adapter builder {relup,compile,repackage,rsync,pearize}.sh pldnotify.awk; do
787 [ -f $a ] || continue
788 ln -sf ../$a $ASSUMED_NAME
789 cvsignore_df $a
790 done
791 fi
792 fi
793
794 if [ ! -f "$ASSUMED_NAME/$SPECFILE" ]; then
795 Exit_error err_no_spec_in_repo
796 fi
797
798 if [ "$CHMOD" = "yes" -a -n "$SPECFILE" ]; then
799 chmod $CHMOD_MODE $ASSUMED_NAME/$SPECFILE
800 fi
801 unset OPTIONS
802 [ -n "$DONT_PRINT_REVISION" ] || grep -E -m 1 "^#.*Revision:.*Date" $ASSUMED_NAME/$SPECFILE
803
804 set_spec_target
805}
806
807find_mirror() {
808 cd "$REPO_DIR"
809 local url="$1"
810 if [ ! -f "mirrors" -a "$NOCVSSPEC" != "yes" ] ; then
811 $CVS_COMMAND update mirrors >&2
812 fi
813
814 IFS="|"
815 local origin mirror name rest ol prefix
816 while read origin mirror name rest; do
817 # skip comments and empty lines
818 if [ -z "$origin" ] || [ "${origin#\#}" != "$origin" ]; then
819 continue
820 fi
821 ol=$(echo -n "$origin" | wc -c)
822 prefix=$(echo -n "$url" | head -c $ol)
823 if [ "$prefix" = "$origin" ] ; then
824 suffix=$(echo "$url" | cut -b $((ol+1))-)
825 echo -n "$mirror$suffix"
826 return 0
827 fi
828 done < mirrors
829 echo "$url"
830}
831
832# Warning: unpredictable results if same URL used twice
833src_no() {
834 cd $PACKAGE_DIR
835 rpm_dump | \
836 grep "SOURCEURL[0-9]*[ ]*$1""[ ]*$" | \
837 sed -e 's/.*SOURCEURL\([0-9][0-9]*\).*/\1/' | \
838 head -n 1 | xargs
839}
840
841src_md5() {
842 [ "$NO5" = "yes" ] && return
843 no=$(src_no "$1")
844 [ -z "$no" ] && return
845 cd $PACKAGE_DIR
846 local md5
847
848 if [ -f additional-md5sums ]; then
849 local spec_rev=$(grep $SPECFILE CVS/Entries 2>/dev/null | sed -e s:/$SPECFILE/:: -e s:/.*::)
850 if [ -z "$spec_rev" ]; then
851 spec_rev=$(head -n 1 $SPECFILE | sed -e 's/.*\$Revision: \([0-9.]*\).*/\1/')
852 fi
853 local spec="$SPECFILE[0-9.,]*,$(echo $spec_rev | sed 's/\./\\./g')"
854 md5=$(grep -s -v '^#' additional-md5sums | \
855 grep -E "[ ]$(basename "$1")[ ]+${spec}([ ,]|\$)" | \
856 sed -e 's/^\([0-9a-f]\{32\}\).*/\1/' | \
857 grep -E '^[0-9a-f]{32}$')
858
859 if [ "$md5" ]; then
860 if [ $(echo "$md5" | wc -l) != 1 ] ; then
861 echo "$SPECFILE: more then one entry in additional-md5sums for $1" 1>&2
862 fi
863 echo "$md5" | tail -n 1
864 return
865 fi
866 fi
867
868 source_md5=`grep -i "^#[ ]*Source$no-md5[ ]*:" $SPECFILE | sed -e 's/.*://'`
869 if [ -n "$source_md5" ]; then
870 echo $source_md5
871 else
872 source_md5=`grep -i "BuildRequires:[ ]*digest(%SOURCE$no)[ ]*=" $SPECFILE | sed -e 's/.*=//'`
873 if [ -n "$source_md5" ]; then
874 echo $source_md5
875 else
876 # we have empty SourceX-md5, but it is still possible
877 # that we have NoSourceX-md5 AND NoSource: X
878 nosource_md5=`grep -i "^#[ ]*NoSource$no-md5[ ]*:" $SPECFILE | sed -e 's/.*://'`
879 if [ -n "$nosource_md5" -a -n "`grep -i "^NoSource:[ ]*$no$" $SPECFILE`" ] ; then
880 echo $nosource_md5
881 fi
882 fi
883 fi
884}
885
886distfiles_path() {
887 echo "by-md5/$(src_md5 "$1" | sed -e 's|^\(.\)\(.\)|\1/\2/&|')/$(basename "$1")"
888}
889
890distfiles_url() {
891 echo "$PROTOCOL$DISTFILES_SERVER/distfiles/$(distfiles_path "$1")"
892}
893
894distfiles_attic_url() {
895 echo "$PROTOCOL$ATTICDISTFILES_SERVER/distfiles/Attic/$(distfiles_path "$1")"
896}
897
898good_md5() {
899 md5=$(src_md5 "$1")
900 [ "$md5" = "" ] || \
901 [ "$md5" = "$(md5sum $(nourl "$1") 2> /dev/null | sed -e 's/ .*//')" ]
902}
903
904good_size() {
905 size=$(find $(nourl "$1") -printf "%s" 2>/dev/null)
906 [ -n "$size" -a "$size" -gt 0 ]
907}
908
909cvsignore_df() {
910 if [ "$CVSIGNORE_DF" != "yes" ]; then
911 return
912 fi
913 cvsignore=${PACKAGE_DIR}/.cvsignore
914
915 # add only if not yet there
916 if ! awk -vf="$1" -vc=1 '$0 == f { c = 0 } END { exit c }' $cvsignore 2>/dev/null; then
917 echo "$1" >> $cvsignore
918 fi
919}
920
921cvsup() {
922 update_shell_title "cvsup"
923 local OPTIONS="" ACTION="up"
924
925 # checkout
926 if [ "$1" = "-c" ]; then
927 ACTION="co"
928 shift
929 fi
930 # add
931 if [ "$1" = "-a" ]; then
932 ACTION="add"
933 shift
934 fi
935
936 OPTIONS="$ACTION "
937
938 if [ -n "$CVSROOT" ]; then
939 OPTIONS="-d $CVSROOT $OPTIONS"
940 fi
941
942 if [ "$ACTION" != "add" ]; then
943 if [ -z "$CVSDATE" -a -z "$CVSTAG" ]; then
944 OPTIONS="$OPTIONS -A"
945 else
946 if [ -n "$CVSDATE" ]; then
947 OPTIONS="$OPTIONS -D $CVSDATE"
948 fi
949 if [ -n "$CVSTAG" ]; then
950 # FIXME: cvs add actually works with -r ?
951 OPTIONS="$OPTIONS -r $CVSTAG"
952 fi
953 fi
954 fi
955
956 local result=1
957 local retries_counter=0
958 if [ $# = 1 ]; then
959 update_shell_title "cvsup: $*"
960 else
961 update_shell_title "cvsup: $# files"
962 fi
963 while [ "$result" != "0" -a "$retries_counter" -le "$CVS_RETRIES" ]; do
964 retries_counter=$(( $retries_counter + 1 ))
965 output=$(LC_ALL=C $CVS_COMMAND $OPTIONS "$@" 2>&1)
966 result=$?
967 [ -n "$output" ] && echo "$output"
968 if echo "$output" | grep -qE "(Cannot connect to|connect to .* failed|Connection reset by peer|Connection timed out|Unknown host)" \
969 && [ "$result" -ne "0" -a "$retries_counter" -le "$CVS_RETRIES" ]; then
970 echo "Trying again [$*]... ($retries_counter)"
971 update_shell_title "cvsup: retry #$retries_counter"
972 sleep 2
973 continue
974 else
975 break
976 fi
977 done
978 update_shell_title "cvsup: done!"
979 return $result
980}
981
982# returns true if "$1" is ftp, http or https protocol url
983is_url() {
984 case "$1" in
985 ftp://*|http://*|https://*)
986 return 0
987 ;;
988 esac
989 return 1
990}
991
992update_md5() {
993 if [ $# -eq 0 ]; then
994 return
995 fi
996
997 update_shell_title "update md5"
998 if [ -n "$DEBUG" ]; then
999 set -x
1000 set -v
1001 fi
1002
1003 cd "$PACKAGE_DIR"
1004
1005 # pass 1: check files to be fetched
1006 local todo
1007 local need_files
1008 for i in "$@"; do
1009 local fp=$(nourl "$i")
1010 local srcno=$(src_no "$i")
1011 if [ -n "$ADD5" ]; then
1012 [ "$fp" = "$i" ] && continue # FIXME what is this check doing?
1013 grep -qiE '^#[ ]*Source'$srcno'-md5[ ]*:' $PACKAGE_DIR/$SPECFILE && continue
1014 grep -qiE '^BuildRequires:[ ]*digest[(]%SOURCE'$srcno'[)][ ]*=' $PACKAGE_DIR/$SPECFILE && continue
1015 else
1016 grep -qiE '^#[ ]*Source'$srcno'-md5[ ]*:' $PACKAGE_DIR/$SPECFILE || grep -qiE '^BuildRequires:[ ]*digest[(]%SOURCE'$srcno'[)][ ]*=' $PACKAGE_DIR/$SPECFILE || continue
1017 fi
1018 if [ ! -f "$fp" ] || [ $ALWAYS_CVSUP = "yes" ]; then
1019 need_files="$need_files $i"
1020 fi
1021 done
1022
1023 # pass 1a: get needed files
1024 if [ "$need_files" ]; then
1025 get_files $need_files
1026 fi
1027
1028 # pass 2: proceed with md5 adding or updating
1029 for i in "$@"; do
1030 local fp=$(nourl "$i")
1031 local srcno=$(src_no "$i")
1032 local md5=$(grep -iE '^#[ ]*(No)?Source'$srcno'-md5[ ]*:' $PACKAGE_DIR/$SPECFILE )
1033 if [ -z "$md5" ]; then
1034 md5=$(grep -iE '^[ ]*BuildRequires:[ ]*digest[(]%SOURCE'$srcno'[)][ ]*=' $PACKAGE_DIR/$SPECFILE )
1035 fi
1036 if [ -n "$ADD5" ] && is_url $i || [ -n "$md5" ]; then
1037 local tag="# Source$srcno-md5:\t"
1038 if [[ "$md5" == *NoSource* ]]; then
1039 tag="# NoSource$srcno-md5:\t"
1040 elif [ -n "$USEDIGEST" ]; then
1041 tag="BuildRequires:\tdigest(%SOURCE$srcno) = "
1042 fi
1043 md5=$(md5sum "$fp" | cut -f1 -d' ')
1044 echo "Updating Source$srcno ($md5: $fp)."
1045 perl -i -ne '
1046 print unless (/^\s*#\s*(No)?Source'$srcno'-md5\s*:/i or /^\s*BuildRequires:\s*digest\(%SOURCE'$srcno'\)/i);
1047 print "'"$tag$md5"'\n" if /^Source'$srcno'\s*:\s+/;
1048 ' \
1049 $PACKAGE_DIR/$SPECFILE
1050 fi
1051 done
1052}
1053
1054check_md5() {
1055 local bad
1056 [ "$NO5" = "yes" ] && return
1057
1058 update_shell_title "check md5"
1059
1060 for i in "$@"; do
1061 bad=0
1062 if ! good_md5 "$i"; then
1063 echo -n "MD5 sum mismatch."
1064 bad=1
1065 fi
1066 if ! good_size "$i"; then
1067 echo -n "0 sized file."
1068 bad=1
1069 fi
1070
1071 if [ $bad -eq 1 ]; then
1072 echo " Use -U to refetch sources,"
1073 echo "or -5 to update md5 sums, if you're sure files are correct."
1074 Exit_error err_no_source_in_repo $i
1075 fi
1076 done
1077}
1078
1079get_files() {
1080 update_shell_title "get_files"
1081
1082 if [ -n "$DEBUG" ]; then
1083 set -x
1084 set -v
1085 fi
1086
1087 if [ $# -gt 0 ]; then
1088 cd "$PACKAGE_DIR"
1089
1090 if [ ! -s CVS/Root -a "$NOCVS" != "yes" ]; then
1091 echo "Warning: No CVS access defined for SOURCES"
1092 NOCVS="yes"
1093 fi
1094
1095 local nc=0
1096 local get_files_cvs=""
1097 for i in "$@"; do
1098 nc=$((nc + 1))
1099 local cvsup=0
1100 SHELL_TITLE_PREFIX="get_files[$nc/$#]"
1101 update_shell_title "$i"
1102 local fp=`nourl "$i"`
1103 if [ "$SKIP_EXISTING_FILES" = "yes" ] && [ -f "$fp" ]; then
1104 continue
1105 fi
1106
1107 FROM_DISTFILES=0
1108 local srcmd5=$(src_md5 "$i")
1109
1110 # we know if source/patch is present in cvs/distfiles
1111 # - has md5 (in distfiles)
1112 # - in cvs... ideas?
1113
1114 # CHECK: local file didn't exist or always cvs up (first) requested.
1115 if [ ! -f "$fp" ] || [ $ALWAYS_CVSUP = "yes" ]; then
1116 if echo $i | grep -vE '(http|ftp|https|cvs|svn)://' | grep -qE '\.(gz|bz2)$']; then
1117 echo "Warning: no URL given for $i"
1118 fi
1119 target="$fp"
1120
1121 if [ -z "$NODIST" ] && [ -n "$srcmd5" ]; then
1122 if good_md5 "$i" && good_size "$i"; then
1123 echo "$fp having proper md5sum already exists"
1124 continue
1125 fi
1126
1127 # optionally prefer mirror over distfiles if there's mirror
1128 # TODO: build url list and then try each url from the list
1129 if [ -n "$PREFMIRRORS" ] && [ -z "$NOMIRRORS" ] && im=$(find_mirror "$i") && [ "$im" != "$i" ]; then
1130 url="$im"
1131 else
1132 url=$(distfiles_url "$i")
1133 fi
1134
1135 url_attic=$(distfiles_attic_url "$i")
1136 FROM_DISTFILES=1
1137 # is $url local file?
1138 if [[ "$url" = [./]* ]]; then
1139 update_shell_title "${GETLOCAL%% *}: $url"
1140 ${GETLOCAL} $url $target
1141 else
1142 if [ -z "$NOMIRRORS" ]; then
1143 url=$(find_mirror "$url")
1144 fi
1145
1146 local uri=${url}
1147 # make shorter message for distfiles urls
1148 if [[ "$uri" = ${PROTOCOL}${DISTFILES_SERVER}* ]] || [[ "$uri" = ${PROTOCOL}${ATTICDISTFILES_SERVER}* ]]; then
1149 uri=${uri#${PROTOCOL}${DISTFILES_SERVER}/distfiles/by-md5/?/?/*/}
1150 uri=${uri#${PROTOCOL}${ATTICDISTFILES_SERVER}/distfiles/by-md5/?/?/*/}
1151 uri="df: $uri"
1152 fi
1153 update_shell_title "${GETURI%% *}: $uri"
1154 ${GETURI} ${OUTFILEOPT} "$target" "$url" || \
1155 if [ "`echo $url | grep -E 'ftp://'`" ]; then
1156 update_shell_title "${GETURI2%% *}: $url"
1157 ${GETURI2} ${OUTFILEOPT} "$target" "$url"
1158 fi
1159 fi
1160
1161 # is it empty file?
1162 if [ ! -s "$target" ]; then
1163 rm -f "$target"
1164 if [ `echo $url_attic | grep -E '^(\.|/)'` ]; then
1165 update_shell_title "${GETLOCAL%% *}: $url_attic"
1166 ${GETLOCAL} $url_attic $target
1167 else
1168 if [ -z "$NOMIRRORS" ]; then
1169 url_attic=$(find_mirror "$url_attic")
1170 fi
1171 update_shell_title "${GETURI%% *}: $url_attic"
1172 ${GETURI} ${OUTFILEOPT} "$target" "$url_attic" || \
1173 if [ "`echo $url_attic | grep -E 'ftp://'`" ]; then
1174 update_shell_title "${GETURI2%% *}: $url_attic"
1175 ${GETURI2} ${OUTFILEOPT} "$target" "$url_attic"
1176 fi
1177 test -s "$target" || rm -f "$target"
1178 fi
1179 fi
1180
1181 if [ -s "$target" ]; then
1182 cvsignore_df $target
1183 else
1184 rm -f "$target"
1185 FROM_DISTFILES=0
1186 fi
1187 elif [ "$NOCVS" != "yes" -a -z "$srcmd5" ]; then
1188 if [ $# -gt 1 ]; then
1189 get_files_cvs="$get_files_cvs $fp"
1190 update_shell_title "$fp (will cvs up later)"
1191 cvsup=1
1192 else
1193 cvsup $fp
1194 fi
1195 fi
1196
1197 if [ -z "$NOURLS" ] && [ ! -f "$fp" -o -n "$UPDATE" ] && [ "`echo $i | grep -E 'ftp://|http://|https://'`" ]; then
1198 if [ -z "$NOMIRRORS" ]; then
1199 im=$(find_mirror "$i")
1200 else
1201 im="$i"
1202 fi
1203 update_shell_title "${GETURI%% *}: $im"
1204 ${GETURI} "$im" ${OUTFILEOPT} "$target" || \
1205 if [ "`echo $im | grep -E 'ftp://'`" ]; then
1206 update_shell_title "${GETURI2%% *}: $im"
1207 ${GETURI2} "$im" ${OUTFILEOPT} "$target"
1208 fi
1209 test -s "$target" || rm -f "$target"
1210 fi
1211
1212 if [ "$cvsup" = 1 ]; then
1213 continue
1214 fi
1215
1216 fi
1217
1218 # the md5 check must be moved elsewhere as if we've called from update_md5 the md5 is wrong.
1219 if [ ! -f "$fp" -a "$FAIL_IF_NO_SOURCES" != "no" ]; then
1220 if [ -n "GREEDSRC" ]; then
1221 get_greed_sources $i
1222 else
1223 Exit_error err_no_source_in_repo $i
1224 fi
1225 fi
1226
1227 # we check md5 here just only to refetch immediately
1228 if good_md5 "$i" && good_size "$i"; then
1229 :
1230 elif [ "$FROM_DISTFILES" = 1 ]; then
1231 # wrong md5 from distfiles: remove the file and try again
1232 # but only once ...
1233 echo "MD5 sum mismatch. Trying full fetch."
1234 FROM_DISTFILES=2
1235 rm -f $target
1236 update_shell_title "${GETURI%% *}: $url"
1237 ${GETURI} ${OUTFILEOPT} "$target" "$url" || \
1238 if [ "`echo $url | grep -E 'ftp://'`" ]; then
1239 update_shell_title "${GETURI2%% *}: $url"
1240 ${GETURI2} ${OUTFILEOPT} "$target" "$url"
1241 fi
1242 if [ ! -s "$target" ]; then
1243 rm -f "$target"
1244 update_shell_title "${GETURI%% *}: $url_attic"
1245 ${GETURI} ${OUTFILEOPT} "$target" "$url_attic" || \
1246 if [ "`echo $url_attic | grep -E 'ftp://'`" ]; then
1247 update_shell_title "${GETURI2%% *}: $url_attic"
1248 ${GETURI2} ${OUTFILEOPT} "$target" "$url_attic"
1249 fi
1250 fi
1251 test -s "$target" || rm -f "$target"
1252 fi
1253 done
1254 SHELL_TITLE_PREFIX=""
1255
1256 if [ "$get_files_cvs" ]; then
1257 cvsup $get_files_cvs
1258 fi
1259
1260 if [ "$CHMOD" = "yes" ]; then
1261 CHMOD_FILES=$(nourl "$@")
1262 if [ -n "$CHMOD_FILES" ]; then
1263 chmod $CHMOD_MODE $CHMOD_FILES
1264 fi
1265 fi
1266 fi
1267}
1268
1269make_tagver() {
1270 if [ -n "$DEBUG" ]; then
1271 set -x
1272 set -v
1273 fi
1274
1275 # Check whether first character of PACKAGE_NAME is legal for tag name
1276 if [ -z "${PACKAGE_NAME##[_0-9]*}" -a -z "$TAG_PREFIX" ]; then
1277 TAG_PREFIX=tag_
1278 fi
1279
1280 # NOTE: CVS tags may must not contain the characters `$,.:;@'
1281 TAGVER=$(echo $TAG_PREFIX$PACKAGE_NAME-$PACKAGE_VERSION-$PACKAGE_RELEASE | tr '[.@]' '[_#]')
1282
1283 # Remove #kernel.version_release from TAGVER because tagging sources
1284 # could occur with different kernel-headers than kernel-headers used at build time.
1285 # besides, %{_kernel_ver_str} is not expanded.
1286
1287 # TAGVER=auto-ac-madwifi-ng-0-0_20070225_1#%{_kernel_ver_str}
1288 # TAGVER=auto-ac-madwifi-ng-0-0_20070225_1
1289
1290 TAGVER=${TAGVER%#*}
1291 echo -n "$TAGVER"
1292}
1293
1294# bool is_tag_a_branch(tag)
1295#
1296# returns 1 if a tag is a branch set on SPECFILE
1297is_tag_a_branch() {
1298 if [ -n "$DEBUG" ]; then
1299 set -x
1300 set -v
1301 fi
1302
1303 if [ $# -ne 1 ]; then
1304 return 0;
1305 fi
1306
1307 TAG=$1
1308
1309 cd "$PACKAGE_DIR"
1310 $CVS_COMMAND status -v $SPECFILE | grep -Eiq "${TAG}.+(branch: [0-9.]+)"
1311 return $?
1312}
1313
1314tag_files() {
1315 TAG_FILES="$@"
1316
1317 if [ -n "$DEBUG" ]; then
1318 set -x
1319 set -v
1320 fi
1321
1322 echo "Version: $PACKAGE_VERSION"
1323 echo "Release: $PACKAGE_RELEASE"
1324
1325 local TAGVER
1326 if [ "$TAG_VERSION" = "yes" ]; then
1327 TAGVER=`make_tagver`
1328 echo "CVS tag: $TAGVER"
1329 fi
1330 if [ -n "$TAG" ]; then
1331 echo "CVS tag: $TAG"
1332 fi
1333
1334 local OPTIONS="tag $CVS_FORCE"
1335 if [ -n "$CVSROOT" ]; then
1336 OPTIONS="-d $CVSROOT $OPTIONS"
1337 fi
1338
1339 # if a tagname we are about to set already exists
1340 # and happens to be a branch (common case with AC-branch)
1341 # pass -B (allows -F to disturb branch tag)
1342 local _tag=$TAG
1343 if [ "$TAG_VERSION" = "yes" ]; then
1344 _tag=$TAGVER
1345 fi;
1346 is_tag_a_branch $_tag
1347 if [ $? -eq 0 -a $CVS_NSERVER -eq 0 ]; then
1348 OPTIONS="$OPTIONS -B"
1349 fi;
1350
1351 cd "$PACKAGE_DIR"
1352 local tag_files
1353 for i in $TAG_FILES; do
1354 # don't tag files stored on distfiles
1355 [ -n "`src_md5 $i`" ] && continue
1356 local fp=`nourl "$i"`
1357 if [ -f "$fp" ]; then
1358 tag_files="$tag_files $fp"
1359 elif [ -n "GREEDSRC" ]; then
1360 get_greed_sources $i
1361 else
1362 Exit_error err_no_source_in_repo $i
1363 fi
1364 done
1365
1366 if [ "$tag_files" ]; then
1367 if [ "$TAG_VERSION" = "yes" ]; then
1368 update_shell_title "tag sources: $TAGVER"
1369 printf "Tagging %d files\n" $(echo $tag_files | wc -w)
1370 $CVS_COMMAND $OPTIONS $TAGVER $tag_files || exit
1371 fi
1372 if [ -n "$TAG" ]; then
1373 update_shell_title "tag sources: $TAG"
1374
1375 while [ "$tag_files" ]; do
1376 local chunk=$(echo $tag_files | tr ' ' '\n' | head -n 100)
1377 printf "Tagging %d files\n" $(echo $chunk | wc -w)
1378 $CVS_COMMAND $OPTIONS $TAG $chunk || exit
1379 tag_files=$(echo $tag_files | tr ' ' '\n' | tail +101)
1380 done
1381 fi
1382 fi
1383
1384 cd "$PACKAGE_DIR"
1385 if [ "$TAG_VERSION" = "yes" ]; then
1386 update_shell_title "tag spec: $TAGVER"
1387 $CVS_COMMAND $OPTIONS $TAGVER $SPECFILE || exit
1388 fi
1389 if [ -n "$TAG" ]; then
1390 update_shell_title "tag spec: $TAG"
1391 $CVS_COMMAND $OPTIONS $TAG $SPECFILE || exit
1392 fi
1393}
1394
1395branch_files() {
1396 TAG=$1
1397 echo "CVS branch tag: $TAG"
1398 shift
1399
1400 TAG_FILES="$@"
1401
1402 if [ -n "$DEBUG" ]; then
1403 set -x
1404 set -v
1405 fi
1406
1407 local OPTIONS="tag $CVS_FORCE -b"
1408
1409 # branch exists?
1410 is_tag_a_branch $TAG
1411 if [ $? -eq 1 ]; then
1412 OPTIONS="$OPTIONS -B"
1413 fi
1414
1415 if [ -n "$CVSROOT" ]; then
1416 OPTIONS="-d $CVSROOT $OPTIONS"
1417 fi
1418 cd "$PACKAGE_DIR"
1419 local tag_files
1420 for i in $TAG_FILES; do
1421 local fp=`nourl "$i"`
1422 if [ -f "$fp" ]; then
1423 tag_files="$tag_files $fp"
1424 elif [ -n "GREEDSRC" ]; then
1425 get_greed_sources $i
1426 else
1427 Exit_error err_no_source_in_repo $i
1428 fi
1429 done
1430 if [ "$tag_files" ]; then
1431 $CVS_COMMAND $OPTIONS $TAG $tag_files || exit
1432 fi
1433
1434 cd "$PACKAGE_DIR"
1435 $CVS_COMMAND $OPTIONS $TAG $SPECFILE || exit
1436}
1437
1438
1439# this function should exit early if package can't be built for this arch
1440# this avoids unneccessary BR filling.
1441check_buildarch() {
1442 local out ret
1443 out=$(minirpm --short-circuit -bp --define "'prep exit 0'" --nodeps $SPECFILE 2>&1)
1444 ret=$?
1445 if [ $ret -ne 0 ]; then
1446 echo >&2 "$out"
1447 exit $ret
1448 fi
1449}
1450
1451# from relup.sh
1452set_release() {
1453 local specfile="$1"
1454 local rel="$2"
1455 local newrel="$3"
1456 sed -i -e "
1457 s/^\(%define[ \t]\+_\?rel[ \t]\+\)$rel\$/\1$newrel/
1458 s/^\(Release:[ \t]\+\)$rel\$/\1$newrel/
1459 " $specfile
1460}
1461
1462set_version() {
1463 local specfile="$1"
1464 local ver="$2" subver=$ver
1465 local newver="$3" newsubver=$newver
1466
1467 # try handling subver, everything that's not numeric-dotted in version
1468 if grep -Eq '%define\s+subver' $specfile; then
1469 subver=$(echo "$ver" | sed -re 's,^[0-9.]+,,')
1470 ver=${ver%$subver}
1471 newsubver=$(echo "$newver" | sed -re 's,^[0-9.]+,,')
1472 newver=${newver%$newsubver}
1473 fi
1474 sed -i -e "
1475 s/^\(%define[ \t]\+_\?ver[ \t]\+\)$ver\$/\1$newver/
1476 s/^\(%define[ \t]\+subver[ \t]\+\)$subver\$/\1$newsubver/
1477 s/^\(Version:[ \t]\+\)$ver\$/\1$newver/
1478 " $specfile
1479}
1480
1481try_upgrade() {
1482 if [ -n "$TRY_UPGRADE" ]; then
1483 local TNOTIFY TNEWVER TOLDVER
1484 update_shell_title "build_package: try_upgrade"
1485
1486 cd "$PACKAGE_DIR"
1487
1488 if [ "$UPGRADE_VERSION" ]; then
1489 TNEWVER=$UPGRADE_VERSION
1490 else
1491 if [ -n "$FLOAT_VERSION" ]; then
1492 TNOTIFY=$($APPDIR/pldnotify.awk ${BE_VERBOSE:+-vDEBUG=1} $SPECFILE -n) || exit 1
1493 else
1494 TNOTIFY=$($APPDIR/pldnotify.awk ${BE_VERBOSE:+-vDEBUG=1} $SPECFILE) || exit 1
1495 fi
1496
1497 # pldnotify.awk does not set exit codes, but it has match for ERROR
1498 # in output which means so.
1499 if [[ "$TNOTIFY" = *ERROR* ]]; then
1500 echo >&2 "$TNOTIFY"
1501 exit 1
1502 fi
1503
1504 TNEWVER=$(echo $TNOTIFY | awk '{ match($4,/\[NEW\]/); print $5 }')
1505 fi
1506
1507 if [ -n "$TNEWVER" ]; then
1508 TOLDVER=`echo $TNOTIFY | awk '{ print $3; }'`
1509 echo "New version found, updating spec file from $TOLDVER to version $TNEWVER"
1510 if [ "$REVERT_BROKEN_UPGRADE" = "yes" ]; then
1511 cp -f $SPECFILE $SPECFILE.bak
1512 fi
1513 chmod +w $SPECFILE
1514 set_release $SPECFILE $PACKAGE_RELEASE 1
1515 set_version $SPECFILE $PACKAGE_VERSION $TNEWVER
1516 parse_spec
1517 if [ "$PACKAGE_VERSION" != "$TNEWVER" ]; then
1518 echo >&2 "Upgrading version failed, you need to update spec yourself"
1519 exit 1
1520 fi
1521 return 1
1522 fi
1523 fi
1524 return 0
1525}
1526
1527build_package() {
1528 update_shell_title "build_package"
1529 if [ -n "$DEBUG" ]; then
1530 set -x
1531 set -v
1532 fi
1533
1534 cd "$PACKAGE_DIR"
1535
1536 case "$COMMAND" in
1537 build )
1538 BUILD_SWITCH="-ba" ;;
1539 build-binary )
1540 BUILD_SWITCH="-bb" ;;
1541 build-source )
1542 BUILD_SWITCH="-bs --nodeps" ;;
1543 build-prep )
1544 BUILD_SWITCH="-bp --nodeps" ;;
1545 build-build )
1546 BUILD_SWITCH="-bc" ;;
1547 build-install )
1548 BUILD_SWITCH="-bi" ;;
1549 build-list )
1550 BUILD_SWITCH="-bl" ;;
1551
1552 esac
1553
1554 update_shell_title "build_package: $COMMAND"
1555 if [ -n "$LOGFILE" ]; then
1556 LOG=`eval echo $LOGFILE`
1557 if [ -d "$LOG" ]; then
1558 echo "Log file $LOG is a directory."
1559 echo "Parse error in the spec?"
1560 Exit_error err_build_fail
1561 fi
1562 if [ -n "$LASTLOG_FILE" ]; then
1563 echo "LASTLOG=$LOG" > $LASTLOG_FILE
1564 fi
1565 RES_FILE=$(tempfile)
1566
1567 (time eval ${NICE_COMMAND} $RPMBUILD $TARGET_SWITCH $BUILD_SWITCH -v $QUIET $CLEAN $RPMOPTS $RPMBUILDOPTS $BCOND --define \'_specdir $PACKAGE_DIR\' --define \'_sourcedir $PACKAGE_DIR\' $SPECFILE; echo $? > $RES_FILE) 2>&1 |tee $LOG
1568 RETVAL=`cat $RES_FILE`
1569 rm $RES_FILE
1570 if [ -n "$LOGDIROK" ] && [ -n "$LOGDIRFAIL" ]; then
1571 if [ "$RETVAL" -eq "0" ]; then
1572 mv $LOG $LOGDIROK
1573 else
1574 mv $LOG $LOGDIRFAIL
1575 fi
1576 fi
1577 else
1578 eval ${NICE_COMMAND} $RPMBUILD $TARGET_SWITCH $BUILD_SWITCH -v $QUIET $CLEAN $RPMOPTS $RPMBUILDOPTS $BCOND --define \'_specdir $PACKAGE_DIR\' --define \'_sourcedir $PACKAGE_DIR\' $SPECFILE
1579 RETVAL=$?
1580 fi
1581 if [ "$RETVAL" -ne "0" ]; then
1582 if [ -n "$TRY_UPGRADE" ]; then
1583 echo "\nUpgrade package to new version failed."
1584 if [ "$REVERT_BROKEN_UPGRADE" = "yes" ]; then
1585 echo "Restoring old spec file."
1586 mv -f $SPECFILE.bak $SPECFILE
1587 fi
1588 echo ""
1589 fi
1590 Exit_error err_build_fail
1591 fi
1592 unset BUILD_SWITCH
1593}
1594
1595nourl() {
1596 echo "$@" | sed 's#\<\(ftp\|http\|https\|cvs\|svn\)://[^ ]*/##g'
1597}
1598
1599install_required_packages() {
1600 run_poldek -vi $1
1601 return $?
1602}
1603
1604find_spec_bcond() { # originally from /usr/lib/rpm/find-spec-bcond
1605 local SPEC="$1"
1606 awk -F"\n" '
1607 /^%changelog/ { exit }
1608 /^%bcond_with/{
1609 match($0, /bcond_with(out)?[ \t]+[_a-zA-Z0-9]+/);
1610 bcond = substr($0, RSTART + 6, RLENGTH - 6);
1611 gsub(/[ \t]+/, "_", bcond);
1612 print bcond
1613 }' $SPEC | LC_ALL=C sort -u
1614}
1615
1616process_bcondrc() {
1617 # expand bconds from ~/.bcondrc
1618 # The file structure is like gentoo's package.use:
1619 # ---
1620 # * -selinux
1621 # samba -mysql -pgsql
1622 # w32codec-installer license_agreement
1623 # php +mysqli
1624 # ---
1625 if ([ -f $HOME/.bcondrc ] || ([ -n $HOME_ETC ] && [ -f $HOME_ETC/.bcondrc ])); then
1626 :
1627 else
1628 return
1629 fi
1630
1631 SN=${SPECFILE%%\.spec}
1632
1633 local bcondrc=$HOME/.bcondrc
1634 [ -n $HOME_ETC ] && [ -f $HOME_ETC/.bcondrc ] && bcondrc=$HOME_ETC/.bcondrc
1635
1636 local bcond_avail=$(find_spec_bcond $SPECFILE)
1637
1638 while read pkg flags; do
1639 # ignore comments
1640 [[ "$pkg" == \#* ]] && continue
1641
1642 # any package or current package?
1643 if [ "$pkg" = "*" ] || [ "$pkg" = "$PACKAGE_NAME" ] || [ "$pkg" = "$SN" ]; then
1644 for flag in $flags; do
1645 local opt=${flag#[+-]}
1646
1647 # use only flags which are in this package.
1648 if [[ $bcond_avail = *${opt}* ]]; then
1649 if [[ $flag = -* ]]; then
1650 if [[ $BCOND != *--with?${opt}* ]]; then
1651 BCOND="$BCOND --without $opt"
1652 fi
1653 else
1654 if [[ $BCOND != *--without?${opt}* ]]; then
1655 BCOND="$BCOND --with $opt"
1656 fi
1657 fi
1658 fi
1659 done
1660 fi
1661 done < $bcondrc
1662 update_shell_title "parse ~/.bcondrc: DONE!"
1663}
1664
1665set_bconds_values() {
1666 update_shell_title "set bcond values"
1667
1668 AVAIL_BCONDS_WITHOUT=""
1669 AVAIL_BCONDS_WITH=""
1670
1671 if grep -Eq '^# *_with' ${SPECFILE}; then
1672 echo >&2 "ERROR: This spec has old style bconds."
1673 exit 1
1674 fi
1675
1676 if ! grep -q '^%bcond' ${SPECFILE}; then
1677 return
1678 fi
1679
1680 local bcond_avail=$(find_spec_bcond $SPECFILE)
1681 process_bcondrc "$SPECFILE"
1682
1683 update_shell_title "parse bconds"
1684
1685 local opt bcond
1686 for opt in $bcond_avail; do
1687 case "$opt" in
1688 without_*)
1689 bcond=${opt#without_}
1690 case "$BCOND" in
1691 *--without?${bcond}*)
1692 AVAIL_BCONDS_WITHOUT="$AVAIL_BCONDS_WITHOUT <$bcond>"
1693 ;;
1694 *)
1695 AVAIL_BCONDS_WITHOUT="$AVAIL_BCONDS_WITHOUT $bcond"
1696 ;;
1697 esac
1698 ;;
1699 with_*)
1700 bcond=${opt#with_}
1701 case "$BCOND" in
1702 *--with?${bcond}*)
1703 AVAIL_BCONDS_WITH="$AVAIL_BCONDS_WITH <$bcond>"
1704 ;;
1705 *)
1706 AVAIL_BCONDS_WITH="$AVAIL_BCONDS_WITH $bcond"
1707 ;;
1708 esac
1709 ;;
1710 *)
1711 echo >&2 "ERROR: unexpected '$opt' in set_bconds_values"
1712 exit 1
1713 ;;
1714 esac
1715 done
1716}
1717
1718run_sub_builder() {
1719 package_name="${1}"
1720 update_shell_title "run_sub_builder $package_name"
1721 #
1722